<?php
add_action('admin_menu', 'jabze_admin_menu');

jabze_admin_warnings();

function jabze_admin_warnings()
{
    global $jabze_domain, $jabze_access_token;

    if (!get_option('jabze_domain') && !$jabze_domain && !get_option('jabze_access_token') && !$jabze_access_token) {
        function jabze_warning()
        {
            global $hook_suffix;
            if ($hook_suffix == 'plugins.php') {
                echo '
                    <div class="updated" style="padding: 0; margin: 0; border: none; background: none;">
                        <style type="text/css">
    .jabze_activate{min-width:825px;border:1px solid #4F800D;padding:5px;margin:15px 0;background:#83AF24;background-image:-webkit-gradient(linear,0% 0,80% 100%,from(#83AF24),to(#4F800D));background-image:-moz-linear-gradient(80% 100% 120deg,#4F800D,#83AF24);-moz-border-radius:3px;border-radius:3px;-webkit-border-radius:3px;position:relative;overflow:hidden}.jabze_activate .aa_a{position:absolute;top:-5px;right:10px;font-size:140px;color:#769F33;font-family:Georgia, "Times New Roman", Times, serif;z-index:1}.jabze_activate .aa_button{font-weight:bold;border:1px solid #029DD6;border-top:1px solid #06B9FD;font-size:15px;text-align:center;padding:9px 0 8px 0;color:#FFF;background:#029DD6;background-image:-webkit-gradient(linear,0% 0,0% 100%,from(#029DD6),to(#0079B1));background-image:-moz-linear-gradient(0% 100% 90deg,#0079B1,#029DD6);-moz-border-radius:2px;border-radius:2px;-webkit-border-radius:2px}.jabze_activate .aa_button:hover{text-decoration:none !important;border:1px solid #029DD6;border-bottom:1px solid #00A8EF;font-size:15px;text-align:center;padding:9px 0 8px 0;color:#F0F8FB;background:#0079B1;background-image:-webkit-gradient(linear,0% 0,0% 100%,from(#0079B1),to(#0092BF));background-image:-moz-linear-gradient(0% 100% 90deg,#0092BF,#0079B1);-moz-border-radius:2px;border-radius:2px;-webkit-border-radius:2px}.jabze_activate .aa_button_border{border:1px solid #006699;-moz-border-radius:2px;border-radius:2px;-webkit-border-radius:2px;background:#029DD6;background-image:-webkit-gradient(linear,0% 0,0% 100%,from(#029DD6),to(#0079B1));background-image:-moz-linear-gradient(0% 100% 90deg,#0079B1,#029DD6)}.jabze_activate .aa_button_container{cursor:pointer;display:inline-block;background:#DEF1B8;padding:5px;-moz-border-radius:2px;border-radius:2px;-webkit-border-radius:2px;width:266px}.jabze_activate .aa_description{position:absolute;top:22px;left:285px;margin-left:25px;color:#E5F2B1;font-size:15px;z-index:1000}.jabze_activate .aa_description strong{color:#FFF;font-weight:normal}
                        </style>
                            <div class="jabze_activate">
                                <div class="aa_a">B</div>
                                <div class="aa_button_container">
                                    <div class="aa_button_border">
                                        <div class="aa_button"><a href="' . esc_url(add_query_arg(array('page' => 'jabze-key-config'))) . '">Activate your Jabze Chat account</a></div>
                                    </div>
                                </div>
                                <div class="aa_description"><strong>Almost done</strong> - activate your account .</div>
                            </div>
                    </div>
                   ';
            }
        }

        add_action('admin_notices', 'jabze_warning');
        return;
    }
}


function jabze_admin_init()
{
    global $wp_version;

    // all admin functions are disabled in old versions
    if (!function_exists('is_multisite') && version_compare($wp_version, '3.0', '<')) {

        function jabze_version_warning()
        {
            echo '
            <div id="jabze-warning" class="updated fade"><p><strong>' . sprintf(__('jabze %s requires WordPress 3.0 or higher.'), JABZE_VERSION) . '</strong> ' . sprintf(__('Please <a href="%s">upgrade WordPress</a> to a current version'), 'http://codex.wordpress.org/Upgrading_WordPress') . '</p></div>
            ';
        }

        add_action('admin_notices', 'jabze_version_warning');

        return;
    }

    if (function_exists('get_plugin_page_hook'))
        $hook = get_plugin_page_hook('jabze-sync-users', 'index.php');
    else
        $hook = 'dashboard_page_jabze-sync-users';
    add_meta_box('jabze-status', __('Comment History'), 'jabze_comment_status_meta_box', 'comment', 'normal');
}

add_action('admin_init', 'jabze_admin_init');

add_action('admin_enqueue_scripts', 'jabze_load_js_and_css');

function jabze_load_js_and_css()
{
    global $hook_suffix;
    if (in_array($hook_suffix, array(
        'plugins_page_jabze-key-config',
        'plugins_page_jabze-sync-users',
    ))
    ) {
        wp_register_style('admin.css', JABZE_PLUGIN_URL . 'admin.css', array(), '2.5.4.4');
        wp_enqueue_style('admin.css');

        wp_register_script('admin.js', JABZE_PLUGIN_URL . 'admin.js', array('jquery'), '2.5.4.6');
        wp_enqueue_script('admin.js');
        wp_localize_script('admin.js', 'WPjabze', array(
            'comment_author_url_nonce' => wp_create_nonce('comment_author_url_nonce')
        ));
    }
}


function jabze_nonce_field($action = -1)
{
    return wp_nonce_field($action);
}

$jabze_nonce = 'jabze-update-key';

function jabze_plugin_action_links($links, $file)
{
    if ($file == plugin_basename(dirname(__FILE__) . '/jabze.php')) {
        $links[] = '<a href="' . admin_url('admin.php?page=jabze-key-config') . '">' . __('Settings') . '</a>';
    }

    return $links;
}

add_filter('plugin_action_links', 'jabze_plugin_action_links', 10, 2);


/*
 * jabze conf page
 */
function jabze_conf()
{
    global $jabze_nonce, $jabze_domain, $jabze_access_token;
    $show_key_form = $jabze_domain && $jabze_access_token;

    $key_status = '';
    $token_status = '';
    $saved_ok = false;
    $ms = array();
    $messages = array(
        'key_empty' => array('class' => 'updated fade', 'text' => __('Please enter an domian')),
        'token_empty' => array('class' => 'updated fade', 'text' => __('Please enter an Access Token')),
    );

    ?>
    <div class="wrap jabze">
        <div id="icon-upload" class="icon32"><br></div>
        <h2><?php _e(JABZE_APP_NAME); ?></h2>
        <div id="jabze-message" class="hidden">
            <progress  max="100" id="bcs-progress"></progress><br/>
            <span>Please wait a moment, initializing...<span>
        </div>
        <div id="jabze-no-key" class="<?php echo $show_key_form ? 'hidden' : ''; ?>">
            <p><?php
                //TODO jabze
                _e('To use jabze you may need to sign up for an activation key. Click the button below to get started.'); ?></p>
            <p><?php _e('we will send a small amount of your site info to the jabze service, such as site name, site url and admin email. We use the information only to generate the activation key. Please be assured that we will not send any password. '); ?></p>
            <p>To get started, please enter your company email. We will verify that, and send you a "key"
               to continue the set up steps.</p>
            <table class="form-table">
                <tbody>
                <tr>
                    <th><label for="key"><?php _e('Company Email');?></label></th>
                    <td>
                        <input id="jabze-email" name="jabze_domain" type="text" class="regular-text"><span style="color: red;">*</span>
                        <p class="need-key description"><?php
                            printf(__('You must enter a valid work email address'));?></p>
                    </td>
                </tr>
                </tbody>
            </table>
            <p><input type="checkbox" name="agree" id="agreed"/> I agree to send user id (but not password), email, roles and site information to the Jabze service.</p>
            <input type="submit" class="button button-primary" id="jabze-send-code"  value="<?php echo esc_attr(__('Send activation key to me by email')); ?>"/>
            <br/>
            <br/>
            <a href="javascript:;"  class="switch-have-key"><?php _e('I already have an activation key'); ?></a>
        </div>
        <div id="jabze-verify" class="hidden">
            <p>Please enter the activation key below.</p>
            <table class="form-table">
                <tbody>
                <tr>
                    <th><label for="key"><?php _e('Activation Key');?></label></th>
                    <td>
                        <input id="jabze-verify-code"  type="text" class="regular-text"><span style="color: red;">*</span>
                    </td>
                </tr>
                </tbody>
            </table>

            <input type="submit" class="button button-primary" id="create-new-jabze-key" name='create-new' value="<?php echo esc_attr(__('Activate this site')); ?>"/>
        </div>

    <div id="jabze-finish" class="hidden">
        <h2>Congratulations!</h2>
        <p>You have finished setting up Jabze Chat, now your users will be able to chat with each
        other easily on your side, through the pop-up icon on the lower-right corner.</p>
    </div>

    <div id="jabze-have-key" class="<?php echo $show_key_form ? '' : 'hidden'; ?>">
            <?php if (!empty($_POST['update-bcs-key']) && $saved_ok) : ?>
                <div id="message" class="updated fade"><p><strong><?php _e('Settings saved.') ?></strong></p></div>
            <?php endif; ?>
            <?php foreach ($ms as $m) : ?>
                <div class="<?php echo $messages[$m]['class']; ?>"><p>
                        <strong><?php echo $messages[$m]['text']; ?></strong></p></div>
            <?php endforeach; ?>
            <table class="form-table">
                <tbody>
                <tr>
                    <th><label for="key"><?php _e('Email Domain Name');?></label></th>
                    <td>
                        <input id="jabze_domain" name="jabze_domain" type="text" size="15" maxlength="64"
                               value="<?php echo esc_html($jabze_domain); ?>"
                               class="regular-text code <?php echo $key_status; ?>">

                        <div
                            class="under-input key-status <?php echo $key_status; ?>"><?php echo ucfirst($key_status);?></div>
                        <p class="need-key description"><?php printf(__('This is the email domain name for your organization'));?></p>
                    </td>
                </tr>
                <tr>
                    <th><label for="key"><?php _e('Jabze Chat Access Token');?></label></th>
                    <td>
                        <input id="jabze-access-token" name="jabze_access_token" type="text" size="40"
                               maxlength="32" value="<?php echo esc_html($jabze_access_token); ?>"
                               class="regular-text code <?php echo $token_status; ?>">

                        <div
                            class="under-input key-status <?php echo $token_status; ?>"><?php echo ucfirst($token_status);?></div>
                        <p class="need-key description"><?php printf(__('We should have pre-filled the access token above, you should rarely have to modify it'));?></p>
                    </td>
                </tr>
                </tbody>
            </table>
            <?php jabze_nonce_field($jabze_nonce) ?>
            <p class="submit">
                <input type="submit"  id="update-bcs-key" class="button button-primary"
                       value="<?php _e('Save Changes'); ?>">
            </p>
            <a href="javascript:;"  class="switch-no-key"><?php _e('I want create new key and token'); ?></a>
        </div>
        <div id="jabze-xmpp-info">
            <h3>
                After setup , you can not only chat in your site but also can login to XMPP server with your company email:
            </h3>
            <p> Bosh Service Url: <a href="<?php echo JABZE_RESTFUl_URL;?>" target="_blank"> <?php echo JABZE_RESTFUl_URL;?></a> </p>

        </div>

    </div>
<?php
}

add_action('wp_ajax_my_action', 'my_action_callback');

function my_action_callback()
{
    if(isset($_POST['sendCode'])){
        $json=  jabze_sendCode();
        echo  json_encode($json);
    }

    if(isset($_POST['create_key'])){
     $json=  jabze_setup();
     echo  json_encode($json);
    }

    if(isset($_POST['update_key'])){
        $json=  jabze_check_key_status();
        echo  json_encode($json);
    }

    if(isset($_POST['sync'])){
        $json=  jabze_sync();
        echo  json_encode($json);
    }


   die(); // this is required to return a proper result
}

function jabze_admin_menu()
{
    if (class_exists('Jetpack')) {
        add_action('jetpack_admin_menu', 'jabze_load_menu');
    } else {
        jabze_load_menu();
    }
}

function jabze_load_menu()
{
    if (class_exists('Jetpack')) {
        add_submenu_page('jetpack', __(JABZE_APP_NAME), __(JABZE_APP_NAME), 'manage_options', 'jabze-key-config', 'jabze_conf');
    } else {
        add_submenu_page('plugins.php', __(JABZE_APP_NAME), __(JABZE_APP_NAME), 'manage_options', 'jabze-key-config', 'jabze_conf');
    }
}
